package cc.fascinated.bat.features.base.commands.fun;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.CommandInfo;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.Message;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.stereotype.Component;

import java.util.Random;

/**
 * @author Fascinated (fascinated7)
 */
@CommandInfo(
        name = "coinflip",
        description = "Flips a coin",
        userInstall = true
)
@Component
public class CoinFlipCommand extends BatCommand {
    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member,
                        Message commandMessage, String[] arguments, SlashCommandInteraction event) {
        event.reply("%s, you flipped a coin and got **%s**!".formatted(user.getDiscordUser().getAsMention(), flip())).queue();
    }

    /**
     * Flips a coin
     *
     * @return The result of the coin flip
     */
    public String flip() {
        return new Random().nextBoolean() ? "heads" : "tails";
    }
}
